#include "ipv4.h"

#define IP_STRLEN 16

const char * usage = "Usage: ./summary [ip1] - [ip2]";

int main
(int argc, char ** argv)
{
  uint32_t ip1, ip2, hsm, sumroute, sumpfx;

  /* Summary route network ID */
  char sip[IP_STRLEN];
  /* Summary route subnet mask */
  char ssm[IP_STRLEN];
  /* Summary route wildcard mask */
  char wcm[IP_STRLEN];
  
  if (argc != 4 && strcmp(argv[2], "-") != 0)
    {
      printf("%s\n", usage);
      return (EXIT_FAILURE);
    }

  ip1 = parse(argv[1]);
  ip2 = parse(argv[3]);
  hsm = parse("255.255.255.255");

  sumroute = summaryAddress(ip1, hsm, ip2, hsm);
  sumpfx = summaryPrefix(ip1, hsm, ip2, hsm);

  ipntoa(sumroute, sip, IP_STRLEN);
  ipntoa(sumpfx, ssm, IP_STRLEN);
  ipntoa(wildcardMask(sumpfx), wcm, IP_STRLEN);

  printf("Summary IP        Summary Mask      Prefix   Wildcard Mask\n");
  printf("%-15s   %-15s   %-2d       %-15s\n", sip, ssm, prefixLength(sumpfx), wcm);

  return (EXIT_SUCCESS);
}
